import { FeatureStateHolder } from './feature_state';
export interface AnalyticsCollector {
    logEvent(action: string, other: Map<string, string>, featureStateAtCurrentTime: Array<FeatureStateHolder>): any;
}
export interface GoogleAnalyticsApiClient {
    cid(other: Map<string, string>): string;
    postBatchUpdate(batchData: string): void;
}
type GoogleAnalyticsApiClientProvider = () => GoogleAnalyticsApiClient;
export declare class GoogleAnalyticsCollector implements AnalyticsCollector {
    private uaKey;
    private _cid;
    private apiClient;
    static googleAnalyticsClientProvider: GoogleAnalyticsApiClientProvider;
    constructor(uaKey: string, cid?: string, apiClient?: GoogleAnalyticsApiClient);
    set cid(value: string);
    logEvent(action: string, other: Map<string, string>, featureStateAtCurrentTime: Array<FeatureStateHolder>): void;
}
export {};
